Subject: bug#49039: Aspell in Emacs

From: [email-masked]
Date: Tue, 15 Jun 2021 20:03:53 +0200 (CEST)

> From: Eli Zaretskii <[email-masked]>
> To: [email-masked]
> Subject: Re: bug#49039: Aspell in Emacs
> Date: 15/06/2021 19:30:08 Europe/Paris
> Cc: [email-masked]

> > From: [email-masked]
> > Cc: [email-masked]
> > Date: Tue, 15 Jun 2021 19:00:13 +0200 (CEST)
> > 
> > >It isn't a brief mention, it's a whole section dedicated to
> > >spell-checking commands.
> > 
> > There is no mention of ispell-program-name actually.

> If that's the only problem, then I already fixed it about 2 hours ago.

Much gratitude for that.

> > >> Would you seriously consider have a generic spell framework for emacs that
> > >> one can set up to use ispell, aspell etc.
> > 
> > >We already have such a generic framework.
> > 
> > It looks to me that it is basically a hack of ispell, likely the result that it was easier 
> > and quicker for the developer to do it that way. Correct me if I am wrong.

> You are wrong. Please read the code, don't just judge it by the name
of the package (which is just a historic incident).

It is valuable to go past the historic after significant time has passed as it easily leads

to confusion or obfuscation.

May I suggest that the generic framework uses a name which in different that using

the old ispell name. And within that framowork, one could call ispell, aspell or whatever,

so there is no longer a conflict of understanding between ispell the framework and ispell

the program.

> > Had tried lookinf for the self documentation for ispell-program-name, but could not 
> > access anything.

> "C-h v ispell-program-name RET" would have shown its documentation.

There are no matches for ispell-program-name if you try to do C-h v ispell-program-name

> "M-x customize-group RET ispell RET" would have shown you all the
> customizable options for the package.

> > Indeed I had to file a report for people to tell me this.

> I suggest to spend some time learning to use the Emacs help commands,
> such as the two commands I show above, they usually make discovery
> fast and efficient.

> In any case, since Emacs already looks for known spell-checkers, and
> already prefers aspell, my conclusion from the fact that it didn't
> work for you is that you have some unusual setup, which should be
> quite rare nowadays. The defaults are set such that the user will not
> need to know about this variable.

There has been a misunderstanding that aspell was not working.  It was 

working but my impression was that using ispell on emacs was using

ispell the program.

I am convinced that the user should know about the variable.  It is an important

variable and users should know what spell checker is being used.

> > > >If aspell is on PATH, it doesn't matter which form you use. If it is
> >not on PATH, then you should use the absolute file name.
> > 
> > Would you also say that the information is in the manual?

> I don't think it should be. When you install a speller such as
> aspell, if its executable file is not on PATH, your system is
> misconfigured. The Emacs manual is not the place where people should
> look for information about setting up spelling on misconfigured
> systems.

> IOW, spelling with aspell in Emacs should work as long as invoking
> aspell from the shell prompt works. If it doesn't work to invoke
> aspell from the shell prompt, then you should first correct your

> system's configuration so that it does.

Correct, but it is hard to understand what spelling program is being used.

Gnu packages should work well together.  The Gnu Aspell manual says that 

Aspell is a Free and Open Source spell checker designed to eventually replace

Ispell.This creates confusion and emacs should stop using ispell by name,

except when it is actually using the ispell checker.

What shall we call the general emacs spell checker? orthography-mode comes

to mind.  The mode could additionally highlight incorrect words.  Found many people complaining about flyspell.  But the idea of flyspell - that of highlighting misspelled

words - is good and useful in practice.  One can argue that doing the checking on

the fly can be disruptive and slow.  I can accept that.  There can be a command 

(e.g. orthographic-highlight) that can do the highlighting at user request (on paragraph,

region' or buffer context) rather than continuously. 

Many Thanks